--------------------------------------------------------------------------------
-- Copyright (c) 2001 by Trenz Electronic.
-- Duenner Kirchweg 77, 32257 Buende, Germany, www.trenz-electronic.de
--------------------------------------------------------------------------------
-- Project:     TE-XC2S Application Note: Game of Life
-- File:        Color.vhd
-- Description: Color Table
-- History:     2001sep12, FB, Created.
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity Color is
	port(
		pal: in  STD_LOGIC_VECTOR(1 downto 0); -- color palette
		d:   in  STD_LOGIC;                    -- 1bit data input
		r:   out STD_LOGIC;                    -- red
		g:   out STD_LOGIC;                    -- green
		b:   out STD_LOGIC;                    -- blue
		i:   out STD_LOGIC                     -- intensity
		);
end Color;

architecture bhv of Color is
	signal tbl: STD_LOGIC_VECTOR(7 downto 0);
begin
	with pal select tbl<=
	"0010" & "1111" when "00",   -- blue on white
	"1000" & "1111" when "01",   -- red on white
	"0100" & "1111" when "10",   -- green on white
	"1100" & "0010" when others; -- yellow on blue
	
	r<= tbl(7) when d= '1' else tbl(3);
	g<= tbl(6) when d= '1' else tbl(2);
	b<= tbl(5) when d= '1' else tbl(1);
	i<= tbl(4) when d= '1' else tbl(0);
end bhv;

--------------------------------------------------------------------------------
-- end of file
